\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{thesis}[2022/06/27 - Custom thesis typesetting meta package]

% tons of standard math stuff
\usepackage{mkessler-math}

% use \vocab to emphasize + index material
\usepackage{mkessler-vocab}
\let\vocab\emph

% easy reference to theorems inside proofs
\usepackage{mkessler-refproof}

% Manages all the theorems and their styles we will use
\usepackage[number in = chapter]{fancythm}

% Simple enumeration styles h,p,e
\usepackage{mkessler-enumerate}

% manage bibliography
\usepackage[bibfile=bibliography/references.bib, imagefile=bibliography/images.bib]{mkessler-bibliography}

% language support and interalization
\usepackage[ngerman, main=english]{babel}

% \enquote{} for proper enquoting
\usepackage{csquotes}

% simple \todo, \todoquestion, \todoref, \todotypo commands
\usepackage{mkessler-todo}

% some micro management
\usepackage{microtype}

% hyperlinking without colors
\usepackage{hyperref}


%%% Set up environments

% This ensures that star/dagger environments are numbered as usual
\RenewTheoremGroup[]{custom}

% Declaration of used environments
\NewFancyTheorem[thmtools = {style=plain, sibling = inchapter}]{theorem}
\NewFancyTheorem[thmtools = {style=plain, sibling = inchapter}]{lemma}
\NewFancyTheorem[thmtools = {style=plain, sibling = inchapter}]{corollary}
\NewFancyTheorem[thmtools = {style=plain, sibling = inchapter}]{proposition}
\NewFancyTheorem[thmtools = {style=definition, sibling = inchapter}]{definition}
\NewFancyTheorem[thmtools = {style=remark, sibling = inchapter, qed={$\diamond$}}]{example}
\NewFancyTheorem[thmtools = {style=remark, sibling = inchapter, qed={$\diamond$}}]{remark}

% After definitions
\NewDocumentEnvironment{well-definedness}{}
  {
    \begin{oldproof}[Well-definedness]
  }
  {
    \end{oldproof}
  }

% This is currently an ugly hack due to refproof also redefining
% the proof environment (which we don't need) to ensure that proof
% accepts * and + as optional arguments as all other environments
% in the long term, refproof should just handle this, but this
% requires some more work and refactoring so this is fine for now
% as it works

\AtBeginDocument
  {
    \RenewDocumentEnvironment{proof}{!s!t+}
      {\begin{oldproof}[Proof\IfBooleanT{#1}{$*$}\IfBooleanT{#2}{\/$^{\dagger}$}]}
      {\end{oldproof}}
  }
